
#ifndef __ADAPT_H
#define __ADAPT_H

#include <values.h>
#include "ipp.h"

#define CHANGE_INITIAL	2  
#define CHANGE_GOAL     3  
#define TIMEOUT         4
#define PARTIAL_TIMEOUT 5

#define STRONG 10
#define NORMAL 11

#define IS_USED 1
#define CUT_OFF 2

#define MAX_SIZE 3
#define STEP     2

#define NO	0
#define FWD     1
#define BACK    2

//miamod
#define FF_COMM_LINE "./FF-v2.3/ff"
#define IPP4_COMM_LINE "./IPP_4.1/ipp"

//Selezionare qui se si vuole usare o no il planner esterno
#define USE_EXT_PLAN

#ifdef USE_EXT_PLAN
//Selezionare il planner che si intende usare
#define USE_FF
//#define USE_IPP4
#endif

#ifdef USE_IPP4
#define PLANNER_COMM_LINE IPP4_COMM_LINE
#endif

#ifdef USE_FF
#define PLANNER_COMM_LINE FF_COMM_LINE
#endif


#define SEARCH 1
#define OPTIMIZE 2

#define DOMAIN_FILE_NAME "domain.pddl"
#define PROBLEM_FILE_PREFIX "problem"
#define RESULT_FILE_PREFIX "result"

//finemiamod



int backtrack, tot_backtrack;
int *backtrack_list;
int cut_off;
int iniz_step_cut, step_cut;

struct tms start_time, search_start;
float build_ad_time, fixpoint_time;
  
typedef struct ACTION  
{
   token name;
   struct ACTION* next;  
} action;  

action* act_vect[MAX_PLAN+1];   
int correct_vect[MAX_PLAN+1];

token_list store_goal_facts, store_initial_facts;
token_list fact_table_vect[MAX_PLAN+1];
//miamod
token_list inertial_facts;
int level_actions[MAX_PLAN+1];
//finemiamod 

struct ADAPT 
{ 
   int iniz;  
   int plan_length;  
   int sub_plan_length;
   int best_plan_length;
   int change;  
   int graph_length;
   int step;
   int timeout;
   int partial_timeout;
   int num_inc;  
   int num_actions;
   int best_num_actions;
   int all_exclusive;
   int action_remotion;
   int alterna;
   int iteraz;
   int try;
  /* define the type of levels tha has been considered in the optimization */
} adapt;


/* in file load.c */

int load_plan(char *file_plan);
void store_adapted_plan(int levels, char* fact_file_name, double time);


/* in file adapt.c */

//miamod: aggiunto limit type
BOOLEAN adapt_plan(int curr_init_time, int limit_type);
int resize_plan(char* file_name, int limit_type);

BOOLEAN find_act_vect(char* name, int level);
void insert_act_vect(char* name, int level);
void free_act_vect(int level);
void up_act_vect(int level);
void down_act_vect(int level);

void de_alloc(int max_time);
void free_table(hashtable *t, int max_size);
void free_edge_list(edge_list e);
void free_cond_edge_list(cond_edge_list ce);
void free_delete_list(delete_list de);
void free_vertex(vertex_list v);

void print_plan(int time_init, int time_end);
void print_facts_and_goals(int curr_init_time, int curr_max_time);
void print_list(token_list list);


/* in file main.c */

void print_gpg_report(float plan_time, BOOLEAN memory_info);


#endif __ADAPT_H
