
#include "ipp.h"  /* defines, data structures, fn prototypes, global variables */ 
#include "adapt.h" 
#include "gpg.h"
#include "convert.h"


/*  
 * global variables  
 */  
  
  
/* technical variables */  
char *act_filename;  
int lineno = 1;  
inst_effect_list help_inst_effect_list;/* used for del_ALL_quantifiing */  
//BOOLEAN minimize = TRUE;/* has to do with recursive op choice in fn search */  
  
/* globally important variables */  
  
/* domain constants */  
op_list loaded_ops;/* loaded, uninstantiated operators */  
operator_list operators;/* list of instantiated operators */  
token_list initial_facts;/* the initial facts */  
effect_list raw_goal_facts;/* not yet preprocessed goal facts */  
token_list goal_facts;/* the goal facts */  
fact_list orig_constant_list;/* to store all typed objects */  
fact_list orig_initial_facts;/* stores initials as fact_list */  
fact_list negated_preds = NULL;/* needed for NOT preprocessing */   
fact_list types;/* fast access to all objects of one type */  
  

/* setting initial values for adapt */

void initialize_adapt_values()
{

  adapt.iniz;
  adapt.plan_length = MAXINT;
  adapt.sub_plan_length = MAXINT;
  adapt.best_plan_length = MAXINT;
  adapt.change;
  adapt.graph_length;
  adapt.step = 2;  
  adapt.timeout = 1800; 
  adapt.partial_timeout = MAXINT;
  adapt.num_inc = 0;
  adapt.num_actions = 0;
  adapt.best_num_actions = 0;
  adapt.all_exclusive;
  adapt.action_remotion = 1;
  adapt.alterna = FWD;               // NO, FWD, BACK
  adapt.iteraz = 0;
  adapt.try = 0;
  
  cut_off = MAXINT;
  iniz_step_cut = MAXINT;
  step_cut = MAXINT;

}


void print_gpg_options()
{

  printf("\nUsage of fct2pddl:\n");  
  
  printf("\n fct2pddl fact_file_name problem_file_name\n\n");  
  
}

void build_file_name(char* complete_name, char* file_name,
                     char* file_ext, char* path)
{
   char *sExt;   // This is the extension of a file name

   sExt = file_name;
   sExt += (int) (strlen(file_name) - 4);
     // Get last 4 chars of file name
   if ( strcmp ( sExt, file_ext ) )
      strcat( file_name, file_ext );

   strcat( complete_name, path );
   strcat( complete_name, file_name );
}



// -------------------- Main ----------------------------
  
int main( int argc, char *argv[] )  
  
{  
    FILE* ProblemFile;
    char ProbFileName[MAX_LENGTH];  
  int exit_status = 0; /* indicates at end if plan was found, used for PURIFY */  
  char ops_file_name[MAX_LENGTH] = "";/* <ops_file_name>.ops */  
  char fct_file_name[MAX_LENGTH] = "";/* <fct_file_name>.fct */

  char path[MAX_LENGTH]  = "";/* common path for both files */  

  char fct_file[MAX_LENGTH]  = "";/* same for fct file */  

  /* global initialization */
  //initialize_preset_values();
  

  /* no options entered: print usage */  
  if (argc == 1) 
  {  
     print_gpg_options();
     exit( 1 );  
  }  

  argv++;
  strncpy(fct_file_name, *argv, MAX_LENGTH);  
  argv++;
  strncpy(ProbFileName, *argv, MAX_LENGTH);   
  
  
/* no input name at all entered */  
  if ( !ops_file_name[0] && !fct_file_name[0] )
  {  
    printf( "\nipp: at least one inputfile name needed\n\n" );  
    exit( 1 );  
  }  

  
/* only one entered ? => copy from other */  
  if ( !ops_file_name[0] ) strncpy( ops_file_name, fct_file_name, MAX_LENGTH);  
  if ( !fct_file_name[0] ) strncpy( fct_file_name, ops_file_name, MAX_LENGTH);

/* add type suffixes: extension for input files and path info */
  build_file_name(fct_file, fct_file_name,".fct", path);
  load_fct_file( fct_file );

/* preprocessing: enable to use negated facts */  
   preprocess_not();  /* globals changed: negated_preds, initial_facts */  
  
/* convert initials to graph storage */  
   initial_facts = token_list_from_fact_list( orig_initial_facts );  
  
/* preprocessing: remove quantifiers, remove eq() predicates */
   goal_facts = dequantify_goals( raw_goal_facts, &loaded_ops );
  
 

  ProblemFile = fopen (ProbFileName, "w");
  if (ProblemFile == NULL)
  {
      printf ("\nCan't open file %s for writing\n", ProbFileName);
      exit (2);
  }

  write_problem (ProblemFile, types, NULL, initial_facts, goal_facts);

  exit (exit_status);
}



